﻿using Syncfusion.JavaScript.Web;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.Script.Serialization;
using System.Web.Services;
using System.Web.Script.Services;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using Syncfusion.JavaScript.DataSources;
using System.Reflection.Emit;
using System.Reflection;
using System.Threading;

namespace sqlbinding
{
    public partial class _Default : Page
    {
        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static string ButtonQueries(string gridObj)
        {
            //JavaScriptSerializer serializer = new JavaScriptSerializer();
            //IEnumerable div = (IEnumerable)serializer.Deserialize(gridObj, typeof(IEnumerable)); //Retrieves current set of records
            return "success";
        }
        public IEnumerable SqlDataSource1;
        public IEnumerable SqlDataSource2;
        public IEnumerable SqlDataSource3;
        List<Employees> emp = new List<Employees>();
        List<Orders> order = new List<Orders>();
        protected void Page_Load(object sender, EventArgs e)
        {
            emp.Add(new Employees(1, "Nancy", "Sales Representative", "Seattle", "USA"));
            emp.Add(new Employees(2, "Andrew", "Vice President, Sales", "Tacoma", "USA"));
            emp.Add(new Employees(3, "Janet", "Sales Representative", "Kirkland", "USA"));
            emp.Add(new Employees(4, "Margaret", "Sales Representative", "Redmond", "USA"));
            emp.Add(new Employees(5, "Steven", "Sales Manager", "London", "UK"));
            emp.Add(new Employees(6, "Michael", "Sales Representative", "London", "UK"));
            emp.Add(new Employees(7, "Robert", "Sales Representative", "London", "UK"));
            emp.Add(new Employees(8, "Laura", "Inside Sales Coordinator", "Seattle", "USA"));
            emp.Add(new Employees(9, "Anne", "Sales Representative", "London", "UK"));

            this.EmployeesGrid.DataSource = emp;
            this.EmployeesGrid.DataBind();

            DataView dv = (DataView)this.childData.Select(DataSourceSelectArguments.Empty);
            DataView dv1 = (DataView)this.childData1.Select(DataSourceSelectArguments.Empty);
            DataView dv2 = (DataView)this.childData2.Select(DataSourceSelectArguments.Empty);
            DataTable dt = dv.ToTable();
            DataTable dt1 = dv1.ToTable();
            DataTable dt2 = dv2.ToTable();

            this.SqlDataSource1 = ToDynamicList(dt);//dt.AsEnumerable().ToList();
            this.SqlDataSource2 = ToDynamicList(dt1);
            this.SqlDataSource3 = ToDynamicList(dt2);
        }
        public List<dynamic> ToDynamicList(DataTable dt)
        {
            List<string> cols = (dt.Columns.Cast<DataColumn>()).Select(column => column.ColumnName).ToList();
            var dictData = ToDictionary(dt);
            return ToDynamicList(dictData, getNewObject(cols, dictData));
        }
        public List<dynamic> ToDynamicList(List<Dictionary<string, object>> list, Type TypeObj)
        {
            dynamic temp = new List<dynamic>();
            foreach (Dictionary<string, object> step in list)
            {
                object Obj = Activator.CreateInstance(TypeObj);
                PropertyInfo[] properties = Obj.GetType().GetProperties();
                Dictionary<string, object> DictList = (Dictionary<string, object>)step;
                foreach (KeyValuePair<string, object> keyValuePair in DictList)
                {
                    foreach (PropertyInfo property in properties)
                    {
                        if (property.Name == keyValuePair.Key)
                        {
                            var convertedValue = keyValuePair.Value == System.DBNull.Value ? null : keyValuePair.Value;
                            property.SetValue(Obj, convertedValue, null);
                            break;
                        }
                    }
                }
                temp.Add(Obj);
            }
            return temp;
        }
        public List<Dictionary<string, object>> ToDictionary(DataTable dt)
        {
            var columns = dt.Columns.Cast<DataColumn>();
            var Temp = dt.AsEnumerable().Select(dataRow => columns.Select(column =>
                                 new { Column = column.ColumnName, Value = dataRow[column] })
                             .ToDictionary(data => data.Column, data => data.Value)).ToList();
            return Temp.ToList();
        }
        private Type getNewObject(List<string> list, List<Dictionary<string, object>> dictList)
        {
            AssemblyName assemblyName = new AssemblyName();
            assemblyName.Name = "tmpAssembly";
            AssemblyBuilder assemblyBuilder = Thread.GetDomain().DefineDynamicAssembly(assemblyName, AssemblyBuilderAccess.Run);
            ModuleBuilder module = assemblyBuilder.DefineDynamicModule("tmpModule");
            TypeBuilder typeBuilder = module.DefineType("ejGrid", TypeAttributes.Public);
            List<string> colType = new List<string>();
            bool flag = true;
            if (flag)
            {
                foreach (Dictionary<string, object> dictStep in dictList)
                {
                    flag = false;
                    Dictionary<string, object> DictList = (Dictionary<string, object>)dictStep;
                    foreach (KeyValuePair<string, object> keyValuePair in DictList)
                    {
                        var type = keyValuePair.Value.GetType().ToString();
                        colType.Add(type);
                    }
                }
            }
            foreach (string step in list)
            {
                int inx = list.IndexOf(step);
                var type = colType[inx];
                string propertyName = step;
                FieldBuilder field = typeBuilder.DefineField(propertyName, Type.GetType(type), FieldAttributes.Public);
                PropertyBuilder property = typeBuilder.DefineProperty(propertyName, System.Reflection.PropertyAttributes.None, typeof(string), new Type[] { typeof(string) });
                MethodAttributes GetSetAttr = MethodAttributes.Public | MethodAttributes.HideBySig;
                MethodBuilder currGetPropMthdBldr = typeBuilder.DefineMethod("get_value", GetSetAttr, Type.GetType(type), Type.EmptyTypes);
                ILGenerator currGetIL = currGetPropMthdBldr.GetILGenerator();
                currGetIL.Emit(OpCodes.Ldarg_0);
                currGetIL.Emit(OpCodes.Ldfld, field);
                currGetIL.Emit(OpCodes.Ret);
                MethodBuilder currSetPropMthdBldr = typeBuilder.DefineMethod("set_value", GetSetAttr, null, new Type[] { Type.GetType(type) });
                ILGenerator currSetIL = currSetPropMthdBldr.GetILGenerator();
                currSetIL.Emit(OpCodes.Ldarg_0);
                currSetIL.Emit(OpCodes.Ldarg_1);
                currSetIL.Emit(OpCodes.Stfld, field);
                currSetIL.Emit(OpCodes.Ret);
                property.SetGetMethod(currGetPropMthdBldr);
                property.SetSetMethod(currSetPropMthdBldr);
            }
            Type obj = typeBuilder.CreateType();
            return obj;
        }
        private void BindDataSource()
        {
            if ((List<Orders>)Session["InlineEditDataSource"] == null)
            {
                int orderId = 10643;
                int empId = 0;
                for (int i = 1; i < 9; i++)
                {
                    order.Add(new Orders(orderId + 1, "ALFKI", i, 32.38, "Alfreds Futterkiste ", "Germany", 1));
                    order.Add(new Orders(orderId + 2, "ANATR", i, 11.61, "Ana Trujillo Emparedados y helados", "Mexico", 0));
                    order.Add(new Orders(orderId + 3, "ANTON", i, 45.34, "Antonio Moreno Taquería", "Mexico", 1));
                    order.Add(new Orders(orderId + 4, "AROUT", i, 37.28, "Around the Horn", "UK", 0));
                    order.Add(new Orders(orderId + 5, "BERGS", i, 67.00, "Berglunds snabbköp", "Sweden", 1));
                    order.Add(new Orders(orderId + 6, "BLONP", i, 23.32, "Blondel père et fils", "France", 1));
                    orderId += 6;
                }
            }
            else
            {
                order = (List<Orders>)Session["InlineEditDataSource"];
            }
            //this.OrdersGrid.DataSource = order;
            //this.OrdersGrid.DataBind();
        }
        [Serializable]
        public class Employees
        {
            public Employees()
            {

            }
            public Employees(int EmployeeId, string FirstName, string Title, string City, string Country)
            {

                this.EmployeeID = EmployeeId;
                this.FirstName = FirstName;
                this.Title = Title;
                this.City = City;
                this.Country = Country;
            }
            public int EmployeeID { get; set; }
            public string FirstName { get; set; }
            public string Title { get; set; }
            public string City { get; set; }
            public string Country { get; set; }
        }
        [Serializable]
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(int orderId, string customerId, int empId, double freight, string shipName, string shipCountry, int Verified)
            {
                this.OrderID = orderId;
                this.CustomerID = customerId;
                this.EmployeeID = empId;
                this.Freight = freight;
                this.ShipName = shipName;
                this.ShipCountry = shipCountry;
                this.Verified = Verified;
            }
            public int OrderID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public string ShipName { get; set; }
            public string ShipCountry { get; set; }
            public int Verified { get; set; }

        }

        protected void EmployeesGrid_ServerRecordClick(object sender, GridEventArgs e)
        {

        }


    }
}